#import xyh
from numpy import sin, linspace, pi, cos, arcsin, arctan, array,where, sqrt, exp,concatenate, polyfit, argmin, argmax,mean
from pylab import plot, show, title, xlabel, ylabel, subplot, yscale, xscale
from scipy import arange, optimize, stats
from scipy.fftpack import fft, ifft, rfft
#import dOmegatoolbox_rev16 as dO
import matplotlib.pyplot as plt 
from mpl_toolkits.axes_grid1 import host_subplot
import string
import os
from Tkinter import *
import mpl_toolkits.axisartist as AA
import matplotlib.lines as mlines
import glob
import time
import datetime
from bisect import bisect

def dsave(filename,data,headline=None,separator=';'):
    '''data: Dateiname
    data = ist data eine xyFunction, wird sie in der Form x,y in einer
       Liste gespeichert. Ist data eine Liste von xyFunctions, werden sie in
       der Form x1,y1,x2,y2,... gespeichert. Ist data eine Liste von arrays,
       werden diese in der Form x,y,z,.. gespeichert.
    headline = optionale erste Zeile
    separator = Trennzeichen ('\t' fr Tab)
    '''
    f=file(filename,'w')
    if not headline is None: f.write(headline+'\n')
    dataneu=[]
    if (type(data) is list) or (type(data) is tuple):
        for d in data:
            try:
                dataneu+=[d.x,d.y]
            except:
                dataneu+=[d]
    else:
        try:
            dataneu=[data.x,data.y]
        except:
            dataneu+=[data]
    imax=0
    for d in dataneu: imax=len(d)
    i=0
    while i<imax:
        line=''
        for d in dataneu:
            if line<>'': line+=separator
            if i<len(d):
                line=line+str(d[i])
            else:
                line=line+" "
        f.write(line+'\n')
        i+=1
    f.close()

def sigphiplot(sig1,sig2,para,labelvec,pname,prin=0,logx=0,logy=0):
    global projectfolder
    linie=['-','--']
    markers = ['x','+']      
    fig, ax1 = plt.subplots()
    plt.subplots_adjust(left=0.15)
    ax2 = ax1.twinx()
    ax1.plot(para, sig1, 'r-', marker='+')
    ax2.plot(para, sig2, 'b--',marker='x')
    ax1.set_xlabel(labelvec[0])
    ax1.set_ylabel(labelvec[1], color='r')
    ax1.tick_params('y', colors='r')
    ax2.set_ylabel(labelvec[2], color='b')
    ax2.tick_params('y', colors='b')
    if logx>0:
        plt.xscale('log')
    if logy>0:
        plt.yscale('log')
    plt.title(pname)    
    plt.grid()
    plt.show()    
    if prin>0:
        plt.savefig(projectfolder + pname+'.png', dpi=300, bbox_inches='tight')
        plt.savefig(projectfolder + pname+'.pdf', bbox_inches='tight')  
        plt.close()
    else:
        plt.show()

def datenaus(project,demodus):
    #global ftab,Rtab,phitab
    ftab=[]
    Rtab=[]
    phitab=[]
    ttab=[]
    fvec=[]
    phivec=[]
    stopdate=[]
    dateiname='structure.xml'
    datei=project+dateiname
    ifile=open(datei,'r')
    a=ifile.readlines()
    ifile.close()
    std=(((a[4]).split('>'))[1].split('<'))[0]
    stopdate.append((time.mktime(datetime.datetime.strptime((std), "%Y-%b-%d %H:%M:%S").timetuple())))
    for i in range(demodus):
        dateiname='dev705_demods_'+str(i)+'_sample_00000.csv'
        datei=project+dateiname
        ifile=open(datei,'r')
        a=ifile.readlines()
        ifile.close()
        a=a[1:]
        frequenz=[]
        R=[]
        phi=[]
        tt=[]
        for line in a:
            line=line.rstrip('\n')
            line=line.split(';')
            chunk=line[0]
            stst=float(line[1])/210000000.
            if line[3]=='frequency':
                try: 
                    frequenz.append([float(x) for x in line[4:]])
                except:
                    pass
            if line[3]=='r':
                try: 
                    R.append([float(x) for x in line[4:]])    
                except:
                    pass
            if line[3]=='phase':
                try: 
                    phi.append([float(x) for x in line[4:]])
                except:
                    pass
            if line[3]=='nexttimestamp':
                try: 
                    tt.append([(float(x)/210000000.) for x in line[4:]])
                except:
                    pass
        ttab.append(tt)
        ftab.append(frequenz)
        Rtab.append(R)
        phitab.append(phi)
    stopdate.append(stst)
    sub=tt[0][0]
    ttt=[]
    for i in tt:
        ttt.append([x-sub+stopdate[0] for x in i])
    return ftab,Rtab,phitab,ttt,stopdate
def harmosz(x,p):
    y = ((p[0]*2*p[1]*p[2])/(sqrt((p[2]**2-x**2)**2+(4*(p[1]**2)*(x**2)))))
    return y
def resi(p,y,x):
    err = y - harmosz(x,p)
    return err

def witekaus(vollpfad):
    wert=[]
    zeit=[]
    temperatur=[]
    ifile=open(wipfad,'r')
    a=ifile.readlines()
    ifile.close()
    a=a[1:]
    for line in a:
        line=line.rstrip('\n')
        line=line.rsplit(';')
        detlef=line[0]
        try :
            d1=time.mktime(time.strptime(((detlef.split(','))[0]), "%d.%m.%Y %H:%M:%S"))*1000.
            d2=float(detlef.split(',')[1])
            zeit.append((d1+d2)/1000.)
            wt=line[9]
            wt=wt.replace(',','.')
            wert.append(float(wt))
            tt=line[13]
            tt=tt.replace(',','.')
            temperatur.append(float(tt))
        except: 
            pass
    return zeit,wert,temperatur

def flowaus(vollpfad):
    wert=[]
    zeit=[]
    n2set=[]
    summa=[]
    ifile=open(vollpfad,'r')
    a=ifile.readlines()
    ifile.close()
    a=a[1:]
    for line in a:
        line=line.rstrip('\n')
        line=line.rsplit()
        ze=line[0]
        ze=ze.replace(',','.')   
        zeit.append(float(ze)*60.)
        wt=line[10]
        wt=float(wt.replace(',','.'))    
        tt=line[2]
        tt=float(tt.replace(',','.'))
        n2set.append(tt)
        zus=tt+wt
        if zus==0:
            zus=10e-23
        summa.append(zus)
        wt=(wt/(zus))*50.
        wert.append(wt)
    return zeit,wert,summa

def teleaus(vollpfad,start):
    wert=[]
    zeit=[]
    wert2=[]
    ifile=open(vollpfad,'r')
    a=ifile.readlines()
    ifile.close()
    a=a[start:]
    for line in a:
        line=line.rstrip('\n')
        line=line.split(',')
        detlef=line[0]
        try :
            d1=time.mktime(time.strptime(detlef, "%m/%d/%Y %H:%M:%S"))
            zeit.append((d1))
            wt=line[1]
            wert.append(float(wt)/1000.)
            tt=line[2]
            wert2.append(float(tt)/1000.)
        except: 
            pass
    return zeit,wert,wert2


def split(arr, size):
     arrs = []
     while len(arr) > size:
         pice = arr[:size]
         arrs.append(pice)
         arr   = arr[size:]
     arrs.append(arr)
     return arrs

def masumread(maspfad):
    global temp,counter
    datei=maspfad.split('\\')
    datei=datei[-1]
    pfad=maspfad.strip(datei)
    ifile=open(maspfad,'r')
    a=ifile.readlines()
    ifile.close()
    a=a[3:]
    del a[-1]
    timev=[]
    counter=[]
    tindex=[]
    temp=[]
    freq=[]
    mamp=[]
    mphase=[]
    ledamp=[]
    ledphase=[]
    cozw=[]
    for line in a:
        line=line.rstrip('\n')
        line=line.replace(',','.')
        line=line.rsplit(' ')    
        try:
            ti=line[0]
            timev.append(float(ti))
            cc=line[1]
            counter.append(float(cc))
            t=line[2]
            tindex.append(float(t))
            tt=(float(line[9])+float(line[10]))/2.
            temp.append(tt)
            ff=line[4]
            freq.append(float(ff))
            mm=line[5]
            mamp.append(float(mm))
            mp=line[6]
            mphase.append(float(mp))
            la=line[7]
            ledamp.append(float(la))
            lp=line[8]
            ledphase.append(float(lp))
            co=line[11]
            cozw.append(float(co))
        except:
            pass
    tindexvec=[]
    timevec=[]
    tempvec=[]
    freqvec=[]
    mampvec=[]
    mphasevec=[]
    ledampvec=[]
    ledphasevec=[]
    covec=[]
    tt=[]
    titi=[]
    tc=[]
    fc=[]
    mc=[]
    mpc=[]
    lc=[]
    lpc=[]
    coc=[]
    for i in range(len(counter)):
        if i==0:
            b=1.
            a=1.
        else:
            if i<len(counter):
                b=float(counter[i])
                a=float(counter[i-1])
                if b>a:
                    tindexvec.append(tt)
                    timevec.append(titi)
                    tempvec.append(tc)
                    freqvec.append(fc)
                    mampvec.append(mc)
                    mphasevec.append(mpc)
                    ledampvec.append(lc)
                    ledphasevec.append(lpc)
                    covec.append(coc)
                    tt=[]
                    titi=[]
                    tc=[]
                    fc=[]
                    mc=[]
                    mpc=[]
                    lc=[]
                    lpc=[]
                    coc=[]
                else:
                    ttt=float(tindex[i])
                    tititi=float(timev[i])
                    tcc=float(temp[i])
                    fcc=float(freq[i])
                    mcc=float(mamp[i])
                    mpcc=float(mphase[i])
                    lcc=float(ledamp[i])
                    lpcc=float(ledphase[i])
                    cocc=float(cozw[i])
                    tt.append(ttt)
                    titi.append(tititi)
                    tc.append(tcc)
                    fc.append(fcc)
                    mc.append(mcc)
                    mpc.append(mpcc)
                    lc.append(lcc)
                    lpc.append(lpcc)
                    coc.append(cocc)
            else:
                tindexvec.append(tt)
                titi.append(tititi)
                tempvec.append(tc)
                freqvec.append(fc)
                mampvec.append(mc)
                mphasevec.append(mpc)
                ledampvec.append(lc)
                ledphasevec.append(lpc)
                covec.append(coc)
    a=len(tempvec[0])
    b=len(tempvec[1])
    c=len(tempvec[-1])
    if a<b:
        del tindexvec[0]
        del tempvec[0]
        del freqvec[0]
        del mampvec[0]
        del mphasevec[0]
        del ledampvec[0]
        del ledphasevec[0]
        del covec[0]
        del timevec[0]
    if c<b:
        del tindexvec[-1]
        del tempvec[-1]
        del freqvec[-1]
        del mampvec[-1]
        del mphasevec[-1]
        del ledampvec[-1]
        del ledphasevec[-1]
        del covec[-1]
        del timevec[-1]
    return tindexvec,tempvec,freqvec,mampvec,mphasevec,ledampvec,ledphasevec,covec,pfad,timevec



def masumreadAlt(maspfad):
    global temp,counter
    datei=maspfad.split('\\')
    datei=datei[-1]
    pfad=maspfad.strip(datei)
    ifile=open(maspfad,'r')
    a=ifile.readlines()
    ifile.close()
    a=a[3:]
    del a[-1]
    timev=[]
    counter=[]
    tindex=[]
    temp=[]
    freq=[]
    mamp=[]
    mphase=[]
    ledamp=[]
    ledphase=[]
    
    for line in a:
        line=line.rstrip('\n')
        line=line.replace(',','.')
        line=line.rsplit(' ')    
        try:
            ti=line[0]
            timev.append(float(ti))
            cc=line[1]
            counter.append(float(cc))
            t=line[2]
            tindex.append(float(t))
            tt=(float(line[9])+float(line[10]))/2.
            temp.append(tt)
            ff=line[4]
            freq.append(float(ff))
            mm=line[5]
            mamp.append(float(mm))
            mp=line[6]
            mphase.append(float(mp))
            la=line[7]
            ledamp.append(float(la))
            lp=line[8]
            ledphase.append(float(lp))
            
        except:
            pass
    tindexvec=[]
    timevec=[]
    tempvec=[]
    freqvec=[]
    mampvec=[]
    mphasevec=[]
    ledampvec=[]
    ledphasevec=[]
    tt=[]
    titi=[]
    tc=[]
    fc=[]
    mc=[]
    mpc=[]
    lc=[]
    lpc=[]
    
    for i in range(len(counter)):
        if i==0:
            b=1.
            a=1.
        else:
            if i<len(counter):
                b=float(counter[i])
                a=float(counter[i-1])
                if b>a:
                    tindexvec.append(tt)
                    timevec.append(titi)
                    tempvec.append(tc)
                    freqvec.append(fc)
                    mampvec.append(mc)
                    mphasevec.append(mpc)
                    ledampvec.append(lc)
                    ledphasevec.append(lpc)
                    tt=[]
                    titi=[]
                    tc=[]
                    fc=[]
                    mc=[]
                    mpc=[]
                    lc=[]
                    lpc=[]
                    
                else:
                    ttt=float(tindex[i])
                    tititi=float(timev[i])
                    tcc=float(temp[i])
                    fcc=float(freq[i])
                    mcc=float(mamp[i])
                    mpcc=float(mphase[i])
                    lcc=float(ledamp[i])
                    lpcc=float(ledphase[i])
                    tt.append(ttt)
                    titi.append(tititi)
                    tc.append(tcc)
                    fc.append(fcc)
                    mc.append(mcc)
                    mpc.append(mpcc)
                    lc.append(lcc)
                    lpc.append(lpcc)
                    
            else:
                tindexvec.append(tt)
                titi.append(tititi)
                tempvec.append(tc)
                freqvec.append(fc)
                mampvec.append(mc)
                mphasevec.append(mpc)
                ledampvec.append(lc)
                ledphasevec.append(lpc)
                
    a=len(tempvec[0])
    b=len(tempvec[1])
    c=len(tempvec[-1])
    if a<b:
        del tindexvec[0]
        del tempvec[0]
        del freqvec[0]
        del mampvec[0]
        del mphasevec[0]
        del ledampvec[0]
        del ledphasevec[0]
        del timevec[0]
    if c<b:
        del tindexvec[-1]
        del tempvec[-1]
        del freqvec[-1]
        del mampvec[-1]
        del mphasevec[-1]
        del ledampvec[-1]
        del ledphasevec[-1]
        del timevec[-1]
    return tindexvec,tempvec,freqvec,mampvec,mphasevec,ledampvec,ledphasevec,pfad,timevec







##########################################################################
############################# FITTING DATA ## ###########################
len(lv)
plt.close()
x=array(fv[-1])
y=array(av[-1])

phi=array(apv[10])
# initial values #
idx = (abs(y - y.max()/2.)).argmin()
delta=abs(argmax(y)-idx)
deltaom=2*delta
alf=sqrt(3)*deltaom
p = [y.max(),alf,x[argmax(y)]]  # [Amax, DeltaOmega, f(maxpos)] #

# optimization # 
pbest = optimize.leastsq(resi,p,args=(y,x),full_output=1)
best_parameters = pbest[0]

##########################################################################
############################# Plotting DATA ## ###########################
fit2=harmosz(x,best_parameters)
plt.plot(x,y,'-',label='Signal',color='r')
plt.plot(x,fit2,'o',label='Fit',color='b')
plt.xlabel('Freq.[Hz]')
plt.ylabel('ampl. [a.u.]')
plt.grid()
plt.title('Signal <-> Fit')
plt.legend()
# show results #
plt.show()
pbest[0]

sigphiplot(x, phi, y, [1,2], pname=['',''], prin=0, logx=0, logy=0)
sigphiplot(y, fit2, x, ['Frequenz','V-Mikro','Fit'], '0ppm SO2', prin=0, logx=0, logy=0)

##########################################################################
############################# Multi DATA Input ###########################

tt=t1
timevec=[]
erg=[]
maxvec=[]
peakvec=[]
deltavec=[]

for i in range(len(f1[0])):
    x=array(f1[0][i])
    y=array(R1[0][i])
    idx = (abs(y - y.max()/2.)).argmin()
    delta=abs(argmax(y)-idx)
    deltaom=2*delta
    alf=sqrt(3)*deltaom
    p = [y.max(),alf,x[argmax(y)]]
    pbest = optimize.leastsq(resi,p,args=(y,x),full_output=1)
    erg.append(pbest[0])
for i in range(len(erg)):
    timevec.append(tt[i][0]-7000.)
    maxvec.append((erg[i][0]-erg[0][0])*30000.)
    peakvec.append(erg[i][2])
    deltavec.append(erg[i][1]*sqrt(3))

#########################################################################
##################reale Konzentration################################




##########################################################################
####################### Multi DATA Input MASUM ###########################
einpfad=u'\\\\ipmlan\\gp\\Projekte\\ISS_Projekte\\ISS_118915_MASUM\\07_Projektdurchfuehrung_Projektarbeitspunkte\\01_Messungen\\2017_November_Hanntel_eigElektronik\\17.11.2017\\MASUM_SO2Sensor_17112017.txt'

einpfad=u'\\\\ipmlan\\gp\\Projekte\\ISS_Projekte\\ISS_118915_MASUM\\07_Projektdurchfuehrung_Projektarbeitspunkte\\01_Messungen\\2017_Dezember_Hantel_eigElektronik\\08.12.2017\\MASUMSO2Sensor_08122017.txt'

einpfad=u'C:\\Users\\pernau\\Desktop\\MASUM_SO2Sensor_17112017.txt'

#alte Datei ohne CO-Spalte
tv,ttv,fv,av,apv,lv,lpv,pfad,tivec=masumreadAlt(einpfad)

#neue Datei mit CO-Spalte
tv,ttv,fv,av,apv,lv,lpv,cov,pfad,tivec=masumread(einpfad)


tt=tv
timevec=[]
erg=[]
maxvec=[]
peakvec=[]
deltavec=[]
ledmax=[]
normmax=[]
tvec=[]
comvec=[]

#alte Datei ohne CO-Spalte
for i in range(len(fv)):
    x=array(fv[i])
    y=array(av[i])
    idx = (abs(y - y.max()/2.)).argmin()
    delta=abs(argmax(y)-idx)
    deltaom=2*delta
    alf=sqrt(3)*deltaom
    p = [y.max(),alf,x[argmax(y)]]
    pbest = optimize.leastsq(resi,p,args=(y,x),full_output=1)
    fmaxx=(pbest[0])[2]
    indf=bisect(fv[i],fmaxx)
    ledmax.append(lv[i][indf])
    timevec.append(tivec[i][indf])
    temp=mean(ttv[i])
    tvec.append(temp)
    erg.append(pbest[0])
a=array(erg)
a=a.transpose()
meanNull=mean(a[0][5:9])
lednull=mean(ledmax[5:9])
numm=range(len(ledmax))
ledmaxx=[(i/ledmax[5]-1.)*100. for i in ledmax]
slope, intercept, r_value, p_value, std_err = stats.linregress(numm,ledmaxx)
slope=-1*slope
timevec=[(i-timevec[0])/60./60. for i in timevec]
for i in range(len(erg)):
    maxvec.append(erg[i][0])
    fmax=(1-erg[i][2]/erg[0][2])*310.
    peakvec.append(fmax) 
    a=((erg[i][0]-erg[0][0])/erg[0][0])
    b= (a*31.2+0.082*fmax)
    nmv=b+i*slope*.5+i*slope*5.*a
    normmax.append(nmv)
    deltavec.append(erg[i][1]*sqrt(3))

#neue Datei mit CO-Spalte
for i in range(len(fv)):
    x=array(fv[i])
    y=array(av[i])
    idx = (abs(y - y.max()/2.)).argmin()
    delta=abs(argmax(y)-idx)
    deltaom=2*delta
    alf=sqrt(3)*deltaom
    p = [y.max(),alf,x[argmax(y)]]
    pbest = optimize.leastsq(resi,p,args=(y,x),full_output=1)
    fmaxx=(pbest[0])[2]
    indf=bisect(fv[i],fmaxx)
    ledmax.append(lv[i][indf])
    timevec.append(tivec[i][indf])
    temp=mean(ttv[i])
    tvec.append(temp)
    comvec.append(mean(cov[i])/1000.)
    erg.append(pbest[0])
a=array(erg)
a=a.transpose()
meanNull=mean(a[0][5:9])
lednull=mean(ledmax[5:9])
numm=range(len(ledmax))
ledmaxx=[(i/ledmax[5]-1.)*100. for i in ledmax]
slope, intercept, r_value, p_value, std_err = stats.linregress(numm,ledmaxx)
slope=-1*slope
timevec=[(i-timevec[0])/60./60. for i in timevec]
for i in range(len(erg)):
    maxvec.append(erg[i][0])
    fmax=(1-erg[i][2]/erg[0][2])*310.
    peakvec.append(fmax) 
    a=((erg[i][0]-erg[0][0])/erg[0][0])
    b= (a*31.2+0.082*fmax)
    nmv=b+i*slope*.5+i*slope*5.*a
    normmax.append(nmv)
    deltavec.append(erg[i][1]*sqrt(3))

#################################################################################
############################Vergleich zweier Messungen############################


##########################################################################
############################# Plotting DATA ## ###########################
plt.close()a=range(len(timevec))sigphiplot(normmax,peakvec, timevec, ['Time [h]','$SO_2$ concentration [ppm]','$CO_2$ concentration [%]'], '$SO_2$ and $CO_2$ processed data', prin=0, logx=0, logy=0)

sigphiplot(normmaxvec,ledmaxx, a, ['Time [h]','Microphone signal [arb. u.]','LED signal [arb. u.]'], '$SO_2$ and $CO_2$ variation raw data', prin=0, logx=0, logy=0)


##########################################################################
############################# Saving Result ## ###########################

filename=pfad+"auswert3_hfp.csv"
dsave(filename,[timevec,maxvec,peakvec,normmaxvec,deltavec], headline="%Zeit,Amplitude , Peakposition ,NormiertesSignal, FWHM", separator=',')

##########################################################################
############################# Play Ground ################################



a=maxvec[:9]
a
a=mean(a)
maxvec=[i-a for i in maxvec]

b=maxvec[207:219]
b
b=mean(b)
b
normmaxvec=[i/(b/50.) for i in maxvec]
